# Preparations

This chapter contains informations about the course material, the required hardware and an installation guide.


## Required Hardware

- [nRF52840 Development Kit (DK)](https://www.nordicsemi.com/Software-and-Tools/Development-Kits/nRF52840-DK)
- [nRF52840 Dongle](https://www.nordicsemi.com/Software-and-tools/Development-Kits/nRF52840-Dongle)
- 2 micro-USB cables
    - ❗️ make sure you're using micro usb cables which can transmit data (some are charging-only; these are not suitable for our workshop)
- 2 available USB-A ports on your laptop / PC (you can use a USB hub if you don't have enough ports)

In this workshop we'll use both the nRF52840 Development Kit (DK) and the nRF52840 Dongle. We'll mainly develop programs for the DK and use the Dongle to assist with some exercises.

For the span of this workshop keep the nRF52840 DK connected to your PC using a micro-USB cable. Connect the USB cable to the J2 port on the nRF52840 DK. Instructions to identify the USB ports on the nRF52840 board can be found in the top level README file.

## Starter code

Project templates and starter code for this workshop can be found at [https://github.com/ferrous-systems/embedded-trainings-2020][repo]

[repo]: https://github.com/ferrous-systems/embedded-trainings-2020

## Required Software
Please [install the required software](./installation.md) before the course starts.

## Course Material
This book contains the material for the beginner and the advanced workshop in embedded Rust. It aims to be as inclusive as possible. This means, that some information is available in several forms, for example pictures and text description. We also use icons so that different kinds of information are visually distiguishable on the first glance. If you have accessibility needs that are not covered, please let us know.

# Icons and Formatting we use
We use Icons to mark different kinds of information in the book:
* ✅ Call for action
* ❗️ Warnings, Details that require special attention
* 🔎 Knowledge, that gets you deeper into the subject, but you do not have to understand it completely to proceed.
* 💬 Descriptions for Accessibility

> Note: Notes like this one contain helpful information
